<template>
  <form @submit.prevent="handleSubmit">
    <vue-suggestion
      class="bg-white shadow-md rounded mb-4 mx-8 divide-gray-400 max-w-md mx-auto"
      :items="available_members"
      v-model="member"
      :setLabel="setLabel"
      :itemTemplate="memberTemplate"
      @changed="inputChange"
      @selected="itemSelected"
      placeholder="Pesquisar candidato"
      :minLen="0"
      inputClasses="rounded mt-8 p-4 hover:bg-gray-200 flex justify-start"
    >
    </vue-suggestion>
    <br />
    <input
      class="bg-purple-800 hover:bg-purple-900 text-white font-bold py-2 px-4 rounded"
      type="submit"
      value="Adicionar"
    />
  </form>
</template>

<script>
import { VueSuggestion } from "vue-suggestion";
import memberTemplate from "./MemberTemplate";

export default {
  name: "AddMemberForm",
  data: function() {
    return {
      member: "",
      memberTemplate,
      available_members: [
        { id: 1, name: "André Andrade" },
        { id: 2, name: "Bruno Buarque" },
        { id: 3, name: "Carol Campos" },
        { id: 4, name: "Danilo de Deus" },
        { id: 5, name: "Emanual Evandro" },
        { id: 6, name: "Francisco Ferdinando" }
      ],
      members_mock: [
        { id: 1, name: "André Andrade" },
        { id: 2, name: "Bruno Buarque" },
        { id: 3, name: "Carol Campos" },
        { id: 4, name: "Danilo de Deus" },
        { id: 5, name: "Emanual Evandro" },
        { id: 6, name: "Francisco Ferdinando" }
      ]
    };
  },
  components: {
    VueSuggestion
  },
  methods: {
    itemSelected(item) {
      this.$data.member = item;
    },
    setLabel(item) {
      return item.name;
    },
    inputChange(text) {
      // your search method
      this.$data.available_members = this.$data.members_mock.filter(item =>
        item.name.toLowerCase().includes(text.toLowerCase())
      );
      // now `items` will be showed in the suggestion list
    },
    handleSubmit() {
      if (this.$data.member) {
        this.$emit("newIntegrant", this.$data.member);
        this.$data.member = "";
      }
    }
  }
};
</script>

<style>
.formMargin {
  margin-bottom: 10px;
}
.inputTextSize {
  font-size: 1.2em;
}

.vue-suggestion .vs__list {
  display: inherit;
  text-align: left;
  width: 100%;
  border: none;
  border-top: none;
  max-height: 400px;
  overflow-y: auto;
  position: relative;
}

.vue-suggestion input {
  display: inherit;
  width: 100%;
  height: 100%;
}

.vue-suggestion .vs__list .vs__list-item {
  background-color: #fff;
  padding: 10px;
  position: relative;
}

.vue-suggestion .vs__list .vs__list-item:last-child {
  border-bottom: none;
}
.vue-suggestion .vs__list .vs__list-item:hover {
  background-color: #eee !important;
}
.vue-suggestion .vs__list,
.vue-suggestion .vs__loading {
  position: relative;
}
.vue-suggestion .vs__list .vs__list-item {
  cursor: pointer;
}
.vue-suggestion .vs__list .vs__list-item.vs__item-active {
  background-color: #f3f6fa;
}
</style>
